library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity domove_addr_gen is
	port(
			m	: in std_logic_vector(2 downto 0);
			step    : in std_logic_vector(2 downto 0);
			addr_a	: out std_logic_vector(4 downto 0);
			addr_b	: out std_logic_vector(4 downto 0)
	);
end domove_addr_gen;

architecture implementation of domove_addr_gen is

  type ram_type is array(31 downto 0) of
    std_logic_vector(4 downto 0);
  signal RAM1 : ram_type := (
    "00000", "00000", "00000", "00000", "00000", "00000", "00000", "00000",
    "00001", "00101", "00011", "00111", "00000", "00110", "00010", "00100",
    "00110", "01001", "00111", "01011", "00100", "01010", "00101", "01000",
    "00010", "01011", "00011", "01010", "00000", "01000", "00001", "01001");
  signal RAM2 : ram_type := (
    "00000", "00000", "00000", "00000", "00000", "00000", "00000", "00000",
    "01110", "10001", "01111", "10000", "01100", "10011", "01101", "10010",
    "01101", "10011", "01110", "10000", "01100", "10010", "01111", "10001", 
    "10010", "01101", "10000", "01111", "10011", "01100", "10001", "01110");
  signal addr : std_logic_vector(4 downto 0);
  
begin

  addr(4 downto 2) <= m;
  addr(1) <= (step(2) and step(1)) or
             (step(1) and step(0)) or
	     (step(2) and step(0));
  addr(0) <= (step(2) and not step(1)) or
             (step(2) and step(0)) or
	     (not step(1) and step(0));

  addr_a <= RAM1(to_integer(unsigned(addr)));
  addr_b <= RAM2(to_integer(unsigned(addr)));

end implementation;
