library ieee;
use ieee.std_logic_1164.all;

entity twist is
	port(
			m	        : in std_logic_vector(2 downto 0);
			step            : in std_logic_vector(2 downto 0);
			data_a_in	: in std_logic_vector(6 downto 0);
			data_b_in	: in std_logic_vector(6 downto 0);
			data_a_out	: out std_logic_vector(6 downto 0);
			data_b_out	: out std_logic_vector(6 downto 0)
	);
end twist;

architecture implementation of twist is

signal ori_a : std_logic_vector(1 downto 0);
signal ori_b : std_logic_vector(1 downto 0);

begin

  data_a_out(6 downto 2) <= data_a_in(6 downto 2);
  data_b_out(6 downto 2) <= data_b_in(6 downto 2);

  with step select ori_a <=
    '0' & not data_a_in(0) when "001",
    '0' & not data_a_in(0) when "010",
    '0' & not data_a_in(0) when "100",
    '0' & not data_a_in(0) when "110",
    "00" when others;

  with m select data_a_out(1 downto 0) <=
    ori_a                 when "000",
    ori_a                 when "001",
    data_a_in(1 downto 0) when others;
	 
  with step select ori_b <=
    data_b_in(0) & (not data_b_in(1) and not data_b_in(0)) when "001",
    (not data_b_in(1) and not data_b_in(0)) & data_b_in(1) when "010",
    data_b_in(0) & (not data_b_in(1) and not data_b_in(0)) when "100",
    (not data_b_in(1) and not data_b_in(0)) & data_b_in(1) when "110",
    "00" when others;

  with m select data_b_out(1 downto 0) <=
    ori_b                 when "000",
    ori_b                 when "001",
    ori_b                 when "010",
    ori_b                 when "011",
    data_b_in(1 downto 0) when others;

end implementation;
